<template>
  <section>
    <b-tabs size="is-medium" class="block">
      <b-tab-item v-for="tab in tabs" :key="tab.labelKey"
                  :label="$t(tab.labelKey)"
                  :icon="tab.icon"
                  header-class="is-capitalized k-title">
        <div v-if="loading" class="card-wrap">
          <div class="card" v-for="i in 10" :key="i">
            <div class="card-image">
              <b-skeleton height="200" />
            </div>
            <div class="card-content">
              <b-skeleton size="is-medium" />
            </div>
          </div>
        </div>
        <template v-else>
          <b-input v-model="gameSearch"
                   rounded
                   :placeholder="$t('games.search')"
                   type="search"
                   icon="search" />
          <div class="card-wrap">
            <game-item v-for="game in filterGames(tab.games)" :key="game.id"
                       :id="game.id"
                       :img="game.img"
                       :name="game.name"
                       :pinned.sync="game.pinned" />
          </div>
        </template>
      </b-tab-item>
    </b-tabs>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';

import GameItem from '@/components/games/GameItem.vue';
import { GameMode, Game } from '@/types/games';
import { MapState } from '../../../decorators';
import { SET_LOADING, SET_GAMES } from '@/store';

@Component({
  components: { GameItem },
})
export default class GamesIndex extends Vue {
  @MapState(['loading'])
  games: Game[] = [];
  gameSearch: string = '';

  async mounted() {
    this.$store.commit(SET_LOADING, true);
    const { data } = await this.$http.get('games/index');

    this.$store.commit(SET_GAMES, data);
    this.$store.commit(SET_LOADING, false);
    this.games = data;
  }

  get tabs(): {
    labelKey: string;
    games: Game[];
    icon: string;
  }[] {
    return [
      {
        labelKey: 'games.favorites',
        games: this.pinnedGames,
        icon: 'heart',
      },
      {
        labelKey: 'games.action',
        games: this.actionGames,
        icon: 'fighter-jet',
      },
      {
        labelKey: 'games.puzzle',
        games: this.puzzleGames,
        icon: 'puzzle-piece',
      },
    ];
  }

  private GamesByMode(mode: GameMode): Game[] {
    return this.games.filter(
      (game: Game) => game.mode === mode
    );
  }

  get actionGames(): Game[] {
    return this.GamesByMode('action');
  }

  get puzzleGames(): Game[] {
    return this.GamesByMode('puzzle');
  }

  get pinnedGames(): Game[] {
    return this.games.filter((game: Game) => game.pinned);
  }

  filterGames(tabGames: Game[]): Game[] {
    return tabGames.filter(
      (game: Game) => {
        return game.name.toLowerCase().includes(
          this.gameSearch.toLowerCase()
        )
      }
    );
  }
}
</script>

<style lang="scss" scoped>
.card-wrap {
  display: flex;
  flex-wrap: wrap;
}

.card {
  margin: 1rem;
  width: 17%;
  min-width: 271px;
}
</style>
